import 'package:flutter_test/flutter_test.dart';
import 'package:sqflite_laravel_style_queries/helper/models/column_types.dart';
import 'package:sqflite_laravel_style_queries/sqflite_laravel_style_queries.dart';
import 'models/UserDbModel.dart';
import 'models/UserBookDbModel.dart';

void main() {
  test('open database', () async {

    // open database
    await SqfliteEasyDb().open();

    // create tables
    await UserDbModel()
        .addColumn(name: "id", type: ColumnType.integer, isPrimaryKey: true, isAutoIncrement: true)
        .addColumn(name: "name", type: ColumnType.text, isNUll: true)
        .addColumn(name: "father_name", type: ColumnType.text, isNUll: true)
        .execute();

    await UserBookDbModel()
        .addColumn(name: "id", type: ColumnType.integer, isPrimaryKey: true, isAutoIncrement: true)
        .addColumn(name: "user_id", type: ColumnType.integer, isNUll: false)
        .addColumn(name: "name", type: ColumnType.text, isNUll: true)
        .execute();

    // insert records
    UserDbModel(name: "hassan mehmood", fatherName: "Khawaja Muhammad Asghar Saqi").insert();
    UserBookDbModel(userId: 1, name: "zahidaz.com").insert();

    // example of get records
    // print(await UserDbModel().get().queryResult);
    // dynamic _users = await UserDbModel().get().queryResult;
    // List<UserDbModel> users = userDbModelFromJsonList(jsonEncode(_users));
    // print(users[0].id);
    // print(users[0].name);
    // print(users[0].fatherName);
  });


}
